<?php

/*
///
// This is the bootstrap file; grabs all the important things the library
// used to but needed separated.
///
*/

ini_set('display_errors', 'On');
error_reporting(E_ALL);

session_start();

require_once '../app/library.php';

// ---------------------------------------------------------------------------- //
// ---------------------------------------------------------------------------- //
/// Autoloader to get all our classes.

const MAP = [
    'Article'        => 'models/Article.php',
    'ArticleComment' => 'models/ArticleComment.php',
    'EpisodeComment' => 'models/EpisodeComment.php',
    'Project'        => 'models/Project.php',
    'Show'           => 'models/Show.php',
    'User'           => 'models/User.php',

    'Router'          => 'router.php',
    'Database'        => 'modules/Database.php',
    'CommunityModule' => 'modules/CommunityModule.php',
    'DisplayModule'   => 'modules/DisplayModule.php',
    'ParserModule'    => 'modules/ParserModule.php',

    'CommunityHub' => 'hubs/CommunityHub.php'
];

spl_autoload_register(function ($class) {
    if (!isset(MAP[$class])) return false;
    require_once '../app/' . MAP[$class];
    return true;
});

// Initialize the database handler
Database::init('../app/database.db');
